% Inversion script and plot
% Fig. 1 for input model
% Fig. 2 for inverted result of 80 raypath (5 stations x 16 rays for each)
% Fig. 3 for inverted result of 40 raypath (5 stations x 8 rays for each)

close all

%damping factor, which is commonly adopted in body wave tomo
damping = 1.0;

GR_more = [ G_more; damping*eye(length(pertur))];
dR_more = [ obs_more'; zeros(length(pertur),1) ];

GR_less = [ G_less; damping*eye(length(pertur))];
dR_less = [ obs_less'; zeros(length(pertur),1) ];

%inversion using lsqr function
mdv_more = lsqr(GR_more,dR_more,1e-3,20);
mdv_less = lsqr(GR_less,dR_less,1e-3,20);


for x0=0:5
    for y0=0:2
        x1(3*x0+y0+1) = x0+0.5;
        y1(3*x0+y0+1) = y0+0.5;
        new_per(y0+1,x0+1) = pertur(3*x0+y0+1);
        new_mdv_more(y0+1,x0+1) = mdv_more(3*x0+y0+1);
        new_mdv_less(y0+1,x0+1) = mdv_less(3*x0+y0+1);
    end
end
figure(1)
colormap(flip(jet));
clims = [-0.2 0.2];
imagesc(x1,y1,new_per,clims)
colorbar

figure(2)
colormap(flip(jet));
clims = [-0.2 0.2];
imagesc(x1,y1,new_mdv_more,clims)
colorbar
hold on
for station=1:5
    for raynum=1:raynum_more
        x2(1) = station;
        x2(2) = raypath_x_more(station,raynum);
        y2(1) = 0.0;
        y2(2) = raypath_y_more(station,raynum);
        plot(x2,y2,'black');

    end
end

figure(3)
colormap(flip(jet));
clims = [-0.2 0.2];
imagesc(x1,y1,new_mdv_less,clims)
colorbar
hold on

for station=1:5
    for raynum=1:raynum_less
        x2(1) = station;
        x2(2) = raypath_x_less(station,raynum);
        y2(1) = 0.0;
        y2(2) = raypath_y_less(station,raynum);
        plot(x2,y2,'black');
    end
end
