% use this script to generate observation (obs_d) and raypath (G)
% matrix which will be used in inversion part

clear all
close all

for i=0:5
    for j=0:2
        index = 3*i + j + 1;
        if (mod((i + j),2) == 0)
            pertur(index) = 0.2;
        else
            pertur(index) = -0.2;
        end
    end
end

y_bot=3;
raynum_more = 16;

for station=1:5
    i = station-1;
    for angle=15:10:165
        j = (angle-15)/10 + 1;
        
        x_inter = (station*sind(angle) - y_bot*cosd(angle))/sind(angle);
        if (x_inter > 0 && x_inter < 6)
            raypath_x_more(station,j) = x_inter;
            raypath_y_more(station,j) = y_bot;
        elseif (x_inter <= 0)
            raypath_x_more(station,j) = 0.0;
            raypath_y_more(station,j) = station*tand(angle);
        else
            raypath_x_more(station,j) = 6.0;
            raypath_y_more(station,j) = (station-6.0)*tand(angle);
        end
        
        sum_length = 0.0;
        for x0=0:5
            for y0=0:2
                top_left(1) = x0;
                top_left(2) = y0;
                
                tmp_length = getlength(top_left,station,angle);
                G_more(raynum_more*i+j,3*x0+y0+1) = tmp_length;
                if (tmp_length < 0)
                    continue;
                end
                sum_length = sum_length + pertur(3*x0+y0+1)*tmp_length;
            end
        end
        obs_more(raynum_more*i+j) = sum_length;
    end
end

raynum_less = 8;

for station=1:5
    i = station-1;
    for angle=55:10:125
        j = (angle-55)/10 + 1;
        
        x_inter = (station*sind(angle) - y_bot*cosd(angle))/sind(angle);
        if (x_inter > 0 && x_inter < 6)
            raypath_x_less(station,j) = x_inter;
            raypath_y_less(station,j) = y_bot;
        elseif (x_inter <= 0)
            raypath_x_less(station,j) = 0.0;
            raypath_y_less(station,j) = station*tand(angle);
        else
            raypath_x_less(station,j) = 6.0;
            raypath_y_less(station,j) = (station-6.0)*tand(angle);
        end
        
        sum_length = 0.0;
        for x0=0:5
            for y0=0:2
                top_left(1) = x0;
                top_left(2) = y0;
                
                tmp_length = getlength(top_left,station,angle);
                G_less(raynum_less*i+j,3*x0+y0+1) = tmp_length;
                if (tmp_length < 0)
                    continue;
                end
                sum_length = sum_length + pertur(3*x0+y0+1)*tmp_length;
            end
        end
        obs_less(raynum_less*i+j) = sum_length;
    end
end